package com.bergerkiller.bukkit.nolagg;

import java.util.Iterator;

import net.minecraft.server.EntityPlayer;
import net.minecraft.server.Packet;
import net.minecraft.server.TileEntity;

import org.bukkit.Chunk;
import org.bukkit.World;
import org.bukkit.craftbukkit.CraftChunk;
import org.bukkit.craftbukkit.CraftWorld;

public class ChunkHandler {	

	public static net.minecraft.server.Chunk getNative(Chunk chunk) {
		return ((CraftChunk) chunk).getHandle();
	}
	public static net.minecraft.server.WorldServer getNative(World world) {
		return ((CraftWorld) world).getHandle();
	}
	public static String toString(Chunk chunk) {
		return "[" + chunk.getX() + "/" + chunk.getZ() + "/" + chunk.getWorld().getName() + "]";
	}
	public static String toString(net.minecraft.server.Chunk chunk) {
		return "[" + chunk.x + "/" + chunk.z + "/" + chunk.world.getWorld().getName() + "]";
	}
		
	/**
	 * This clones the chunk, breaking it loose from the original
	 * Do NOT use this method in async methods!
	 * Use the cloned version only for async saving, as it is partly dereferenced
	 * @param chunk
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static net.minecraft.server.Chunk cloneChunk(net.minecraft.server.Chunk chunk) {
		try {
			net.minecraft.server.Chunk newc = new net.minecraft.server.Chunk(chunk.world, chunk.x, chunk.z);
			newc.bukkitChunk = null;
			if (!transferData(chunk, newc)) return null;
			for (int i = 0; i < newc.entitySlices.length; i++) {
				newc.entitySlices[i].addAll(chunk.entitySlices[i]);
			}
			newc.tileEntities.putAll(chunk.tileEntities);
			return newc;
		} catch (Throwable t) {
			t.printStackTrace();
			return null;
		}
	}
	
	@SuppressWarnings("rawtypes")
	public static void fixEntities(net.minecraft.server.Chunk chunk) {
		Iterator iter;
		net.minecraft.server.Entity e;
		for (int i = 0; i < chunk.entitySlices.length; i++) {
			iter = chunk.entitySlices[i].iterator();
			while (iter.hasNext()) {
				e = (net.minecraft.server.Entity) iter.next();
				if ((int) e.locX >> 4 != chunk.x || (int) e.locZ >> 4 != chunk.z) iter.remove();
			}
		}
	}
	
	public static boolean transferData(net.minecraft.server.Chunk from, net.minecraft.server.Chunk to) {
		try {
			to.b = from.b;
			to.g = from.g;
			to.h = from.h;
			to.i = from.i;
			to.heightMap = from.heightMap;
			to.done = from.done;
			return true;
		} catch (Throwable t) {
			t.printStackTrace();
			return false;
		}
	}
	
	public static boolean canSave(net.minecraft.server.Chunk chunk) {
		return chunk.a(false) && chunk.world.getWorld().isAutoSave();
	}
		
	public static void sendChunk(net.minecraft.server.Chunk c, EntityPlayer player) {
		new BufferedPacket51MapChunk(c).send(player);
		Packet p;
		for (Object o : c.tileEntities.values()) {
			p = ((TileEntity) o).k();
			if (p != null) player.netServerHandler.sendPacket(p);
		}
	}
			
}
